unit Uff_Conv;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls;

type
  TForm1 = class(TForm)
    RadioGroup1: TRadioGroup;
    Label1: TLabel;
    Label2: TLabel;
    RadioGroup2: TRadioGroup;
    btStart: TBitBtn;
    btExit: TBitBtn;
    OpenDialog1: TOpenDialog;
    Memo1: TMemo;
    btOpen: TButton;
    OpenDialog2: TOpenDialog;
    procedure Label1Click(Sender: TObject);
    procedure Label2Click(Sender: TObject);
    procedure btStartClick(Sender: TObject);
    procedure btOpenClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormResize(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

Const MaxBuf=1000000;
var
  Form1: TForm1;
  fin,fout:file;
  b,Signature:byte;  h,w,rlen:integer;
  head,tail:array[1..4] of byte;
  buf:array[1..MaxBuf] of byte;

implementation

{$R *.DFM}

Function FileNameFromLabel(L:TLabel; cle:boolean):string;
var s:string; i:integer;
begin s:=L.Caption; i:=Pos(':',s);
  if cle then L.Caption:=Copy(s,1,i)+' ';
  Delete(s,1,i);
  Result:=Trim(s);
end;

procedure TForm1.Label1Click(Sender: TObject);
begin
  if FileNameFromLabel(Label1,true)<>'' then CloseFile(fin);
  if not OpenDialog1.Execute then Exit;
  {$I+} AssignFile(fin,OpenDialog1.FileName); Reset(fin,1); {$I-}
  if IoResult<>0 then Exit;
  OpenDialog2.InitialDir:=ExtractFileDir(OpenDialog1.FileName);
  OpenDialog2.FileName:=OpenDialog1.FileName+'.tgt';
  Label1.Caption:=Label1.Caption+OpenDialog1.FileName;
  BlockRead(fin,Signature,1);
  Case Signature of
    $FD: RadioGroup1.ItemIndex := 1;  // Lahey Fortran
    $4B: RadioGroup1.ItemIndex := 2;  // Microsoft Fortran
    else RadioGroup1.ItemIndex := 3;  // WatCom Fortran
  end;
  Reset(fin,1);
  btStart.Enabled:=(FileNameFromLabel(Label2,false)<>'');
  With btStart do if Enabled then SetFocus;
end;

procedure TForm1.Label2Click(Sender: TObject);
begin
  if FileNameFromLabel(Label2,true)<>'' then CloseFile(fout);
  if not OpenDialog2.Execute then Exit;
  if OpenDialog2.FileName=FileNameFromLabel(Label1,false) then
    begin ShowMessage('Do not overwrite Source !!!'); Exit; end;
  {$I+} AssignFile(fout,OpenDialog2.FileName); Rewrite(fout,1); {$I-}
  if IoResult<>0 then begin ShowMessage('Cannot assign Target file !!!'); Exit; end;
  Label2.Caption:=Label2.Caption+OpenDialog2.FileName;
  btStart.Enabled:=(FileNameFromLabel(Label1,false)<>'');
  With btStart do if Enabled then SetFocus;
end;

procedure TForm1.btOpenClick(Sender: TObject);
begin
  Label1Click(Sender);
  Label2Click(Sender);
end;

procedure TForm1.btStartClick(Sender: TObject);
var i,j,k,nr,lr,rc,rd:integer;  e:boolean;
procedure ProtOut;
var s:string;
begin if rlen=lr then begin Inc(nr); Exit; end;
  if nr=1 then s:=' ' else s:='s';
  Inc(rc,nr);
  if nr>0 then
    Memo1.Lines.Add(  { IntToStr(rc)+' : '+ }
      IntToStr(nr)+' record'+s+' written.  Len= '+IntToStr(lr)+' bytes.');
  nr:=1; lr:=rlen;
end;
begin nr:=0; lr:=-1; rc:=0; e:=false;
  if FileNameFromLabel(Label1,false)='' then Label1Click(Sender);
  if FileNameFromLabel(Label2,false)='' then Label2Click(Sender);
  RadioGroup1.Enabled:=false;
  RadioGroup2.Enabled:=false;
  Memo1.Lines.Add('Convert '+ RadioGroup1.Items[RadioGroup1.ItemIndex]+
      ' file '+FileNameFromLabel(Label1,false));
  Memo1.Lines.Add('     to '+ RadioGroup2.Items[RadioGroup2.ItemIndex]+
      ' file '+FileNameFromLabel(Label2,false));
  Case RadioGroup1.ItemIndex of
    1,2 : BlockRead(fin,Signature,1);  // skip Signature
     3  : begin BlockRead(fin,head,4,rd); e:=e or (rd<4); end;
  end;
  Case RadioGroup2.ItemIndex of
    2: Signature:=$FD;
    3: Signature:=$4B;
   else Signature:=0;
  end;
  if Signature<>0 then BlockWrite(fout,Signature,1);
  While not e do
  begin rlen:=0;
    if RadioGroup1.ItemIndex<>3 then for i:=1 to 4 do head[i]:=0;
    Case RadioGroup1.ItemIndex of  // read source record
      0 : begin                       // Compaq
            BlockRead(fin,head,4,rd);
            e:=e or (rd<4);
            for i:=4 downto 1 do rlen:=256*rlen+head[i];
            BlockRead(fin,buf,rlen+4,rd);  // record + 4 tail bytes
            e:=e or (rd<rlen+4);
          end;
      1 : begin                       // Lahey
            BlockRead(fin,head[1],1,rd);
            e:=e or (rd<1);
            k:=1+(head[1] mod 4);         // number of head bytes
            for j:=2 to k do BlockRead(fin,head[j],1,rd);
            rlen:=(head[4] shl 22)+(head[3] shl 14)+(head[2] shl 6)+(head[1] shr 2);
            j:=(rlen+k) shr 6;  k:=1;     // number of tail bytes
            While j>0 do begin Inc(k); j:=j shr 8; end;
            BlockRead(fin,buf,rlen+k,rd); // record + k tail bytes
            e:=e or (rd<rlen+k);
          end;
      2 : begin                      // Microsoft
            i:=1;
            Repeat BlockRead(fin,b,1,rd);
              e:=e or (rd<1) or (b=$82);
              if e then Break;              // 82 - EOF
              k:=128; if b<>$81 then k:=b;  // 81 - record continued
              BlockRead(fin,buf[i],k+1,rd); // subrecord + its tail byte
              e:=e or (rd<k+1);
              b:=buf[i+k]; Inc(i,k); Inc(rlen,k);
            Until b<>$81;
          end;
      3 : begin j:=1;               // WatCom
            Repeat k:=0;
              for i:=3 downto 1 do k:=256*k+head[i];
              BlockRead(fin,buf[j],k+4,rd); // record + 4 tail bytes
              e:=e or (rd<k+4);
              Inc(j,k); Inc(rlen,k);
              BlockRead(fin,head,4,rd);
              e:=e or (rd<4);
            Until e or (head[4]<>$80);
          end;
    end;
    ProtOut;
    if rlen>0 then Case RadioGroup2.ItemIndex of  // write target record
      0 : BlockWrite(fout,buf,rlen);       // binary
      1 : begin
            BlockWrite(fout,rlen,4);       // Compaq
            BlockWrite(fout,buf,rlen);
            BlockWrite(fout,rlen,4);
          end;
      2 : begin                            // Lahey
            j:=rlen shr 6;  k:=1;              // number of head bytes
            While j>0 do begin Inc(k); j:=j shr 8; end;
            j:=4*rlen+k-1; BlockWrite(fout,j,k);
            BlockWrite(fout,buf,rlen);
            j:=(rlen+k) shr 6;  k:=1;          // number of tail bytes
            While j>0 do begin Inc(k); j:=j shr 8; end;
            j:=4*(rlen+k)+k-1; BlockWrite(fout,j,k);
          end;
      3 : begin i:=1; j:=$81;              // Microsoft
            While rlen>128 do
            begin
              BlockWrite(fout,j,1);
              BlockWrite(fout,buf[i],128);
              BlockWrite(fout,j,1);
              Inc(i,128); Dec(rlen,128);
            end;
            BlockWrite(fout,rlen,1);
            BlockWrite(fout,buf[i],rlen);
            BlockWrite(fout,rlen,1);
          end;
      4 : begin  j:=0; i:=1;              // WatCom
            Repeat k:=1024;                    // default subrecord Length
              if rlen<k then k:=rlen;
              BlockWrite(fout,k,3); BlockWrite(fout,j,1);
              BlockWrite(fout,buf[i],k);
              BlockWrite(fout,k,3); BlockWrite(fout,j,1);
              j:=$80; Inc(i,k); Dec(rlen,k);
            Until rlen<=0;
          end;
    end;
  end;
  rlen:=0; ProtOut;
  CloseFile(fin); CloseFile(fout);
  FileNameFromLabel(Label1,true);
  FileNameFromLabel(Label2,true);
  RadioGroup1.Enabled:=true;
  RadioGroup2.Enabled:=true;
  btStart.Enabled:=false;
  Memo1.Lines.Add('-------------- Total '+IntToStr(rc)+' records written.');
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
  Memo1.Lines.Add('Converting UnFormatted Files created by various Fortrans.');
  Memo1.Lines.Add('Copyright (C) July 2000.  A.P.Sapojnikov,  Dubna, Russia.');
  Memo1.Lines.Add(' ');
  h:=Height; w:=Width; btOpen.SetFocus;
  ForceCurrentDirectory:=true;
end;

procedure TForm1.FormResize(Sender: TObject);
begin
  Height:=h; Width:=w;    // Resizing isn't permitted !
end;

end.
